  1287 license.bot // Copyright (c) 2006-2008 The Chromium Authors. All rights reserved.
  1287 license.bot // Use of this source code is governed by a BSD-style license that can be
  1287 license.bot // found in the LICENSE file.
     8 initial.commit 
   949 erikkay@google.com #include "build/build_config.h"
   949 erikkay@google.com 
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit #include <windows.h>
     8 initial.commit #include <shellapi.h>
     8 initial.commit #include <shlobj.h>
   944 erikkay@google.com #endif
     8 initial.commit 
     8 initial.commit #include <fstream>
     8 initial.commit #include <iostream>
   944 erikkay@google.com #include <set>
     8 initial.commit 
     8 initial.commit #include "base/base_paths.h"
  4254 evanm@google.com #include "base/file_path.h"
     8 initial.commit #include "base/file_util.h"
     8 initial.commit #include "base/logging.h"
     8 initial.commit #include "base/path_service.h"
     8 initial.commit #include "base/string_util.h"
     8 initial.commit #include "testing/gtest/include/gtest/gtest.h"
  6227 jeremy@chromium.org #include "testing/platform_test.h"
     8 initial.commit 
     8 initial.commit namespace {
     8 initial.commit 
  1089 erikkay@google.com // file_util winds up using autoreleased objects on the Mac, so this needs
  1089 erikkay@google.com // to be a PlatformTest
  1089 erikkay@google.com class FileUtilTest : public PlatformTest {
     8 initial.commit  protected:
     8 initial.commit   virtual void SetUp() {
  1089 erikkay@google.com     PlatformTest::SetUp();
     8 initial.commit     // Name a subdirectory of the temp directory.
     8 initial.commit     ASSERT_TRUE(PathService::Get(base::DIR_TEMP, &test_dir_));
  4254 evanm@google.com     test_dir_ = test_dir_.Append(FILE_PATH_LITERAL("FileUtilTest"));
     8 initial.commit 
     8 initial.commit     // Create a fresh, empty copy of this directory.
     8 initial.commit     file_util::Delete(test_dir_, true);
  4254 evanm@google.com     file_util::CreateDirectory(test_dir_);
     8 initial.commit   }
     8 initial.commit   virtual void TearDown() {
  1089 erikkay@google.com     PlatformTest::TearDown();
     8 initial.commit     // Clean up test directory
   944 erikkay@google.com     ASSERT_TRUE(file_util::Delete(test_dir_, true));
     8 initial.commit     ASSERT_FALSE(file_util::PathExists(test_dir_));
     8 initial.commit   }
     8 initial.commit 
     8 initial.commit   // the path to temporary directory used to contain the test operations
  4254 evanm@google.com   FilePath test_dir_;
     8 initial.commit };
     8 initial.commit 
     8 initial.commit // Collects all the results from the given file enumerator, and provides an
     8 initial.commit // interface to query whether a given file is present.
     8 initial.commit class FindResultCollector {
     8 initial.commit  public:
     8 initial.commit   FindResultCollector(file_util::FileEnumerator& enumerator) {
  6784 avi@google.com     FilePath cur_file;
  6784 avi@google.com     while (!(cur_file = enumerator.Next()).value().empty()) {
  6784 avi@google.com       FilePath::StringType path = cur_file.value();
     8 initial.commit       // The file should not be returned twice.
  4254 evanm@google.com       EXPECT_TRUE(files_.end() == files_.find(path))
     8 initial.commit           << "Same file returned twice";
     8 initial.commit 
     8 initial.commit       // Save for later.
  4254 evanm@google.com       files_.insert(path);
     8 initial.commit     }
     8 initial.commit   }
     8 initial.commit 
     8 initial.commit   // Returns true if the enumerator found the file.
  4254 evanm@google.com   bool HasFile(const FilePath& file) const {
  4254 evanm@google.com     return files_.find(file.value()) != files_.end();
     8 initial.commit   }
  4254 evanm@google.com 
   944 erikkay@google.com   int size() {
   949 erikkay@google.com     return static_cast<int>(files_.size());
   944 erikkay@google.com   }
     8 initial.commit 
     8 initial.commit  private:
  4254 evanm@google.com   std::set<FilePath::StringType> files_;
     8 initial.commit };
     8 initial.commit 
     8 initial.commit // Simple function to dump some text into a new file.
  4254 evanm@google.com void CreateTextFile(const FilePath& filename,
     8 initial.commit                     const std::wstring& contents) {
     8 initial.commit   std::ofstream file;
  4254 evanm@google.com   file.open(WideToUTF8(filename.ToWStringHack()).c_str());
     8 initial.commit   ASSERT_TRUE(file.is_open());
     8 initial.commit   file << contents;
     8 initial.commit   file.close();
     8 initial.commit }
     8 initial.commit 
     8 initial.commit // Simple function to take out some text from a file.
  4254 evanm@google.com std::wstring ReadTextFile(const FilePath& filename) {
   944 erikkay@google.com   wchar_t contents[64];
     8 initial.commit   std::wifstream file;
  4254 evanm@google.com   file.open(WideToUTF8(filename.ToWStringHack()).c_str());
     8 initial.commit   EXPECT_TRUE(file.is_open());
     8 initial.commit   file.getline(contents, 64);
     8 initial.commit   file.close();
     8 initial.commit   return std::wstring(contents);
     8 initial.commit }
     8 initial.commit 
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit uint64 FileTimeAsUint64(const FILETIME& ft) {
     8 initial.commit   ULARGE_INTEGER u;
     8 initial.commit   u.LowPart = ft.dwLowDateTime;
     8 initial.commit   u.HighPart = ft.dwHighDateTime;
     8 initial.commit   return u.QuadPart;
     8 initial.commit }
   944 erikkay@google.com #endif
     8 initial.commit 
     8 initial.commit const struct append_case {
     8 initial.commit   const wchar_t* path;
     8 initial.commit   const wchar_t* ending;
     8 initial.commit   const wchar_t* result;
     8 initial.commit } append_cases[] = {
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit   {L"c:\\colon\\backslash", L"path", L"c:\\colon\\backslash\\path"},
     8 initial.commit   {L"c:\\colon\\backslash\\", L"path", L"c:\\colon\\backslash\\path"},
     8 initial.commit   {L"c:\\colon\\backslash\\\\", L"path", L"c:\\colon\\backslash\\\\path"},
     8 initial.commit   {L"c:\\colon\\backslash\\", L"", L"c:\\colon\\backslash\\"},
     8 initial.commit   {L"c:\\colon\\backslash", L"", L"c:\\colon\\backslash\\"},
     8 initial.commit   {L"", L"path", L"\\path"},
     8 initial.commit   {L"", L"", L"\\"},
   944 erikkay@google.com #elif defined(OS_POSIX)
   944 erikkay@google.com   {L"/foo/bar", L"path", L"/foo/bar/path"},
   944 erikkay@google.com   {L"/foo/bar/", L"path", L"/foo/bar/path"},
   944 erikkay@google.com   {L"/foo/bar//", L"path", L"/foo/bar//path"},
   944 erikkay@google.com   {L"/foo/bar/", L"", L"/foo/bar/"},
   944 erikkay@google.com   {L"/foo/bar", L"", L"/foo/bar/"},
   944 erikkay@google.com   {L"", L"path", L"/path"},
   944 erikkay@google.com   {L"", L"", L"/"},
   944 erikkay@google.com #endif
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, AppendToPath) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(append_cases); ++i) {
     8 initial.commit     const append_case& value = append_cases[i];
     8 initial.commit     std::wstring result = value.path;
     8 initial.commit     file_util::AppendToPath(&result, value.ending);
     8 initial.commit     EXPECT_EQ(value.result, result);
     8 initial.commit   }
     8 initial.commit 
     8 initial.commit #ifdef NDEBUG
     8 initial.commit   file_util::AppendToPath(NULL, L"path");  // asserts in debug mode
     8 initial.commit #endif
     8 initial.commit }
     8 initial.commit 
     8 initial.commit static const struct InsertBeforeExtensionCase {
     8 initial.commit   std::wstring path;
  6387 estade@chromium.org   FilePath::StringType suffix;
     8 initial.commit   std::wstring result;
     8 initial.commit } kInsertBeforeExtension[] = {
  6387 estade@chromium.org   {L"", FILE_PATH_LITERAL(""), L""},
  6387 estade@chromium.org   {L"", FILE_PATH_LITERAL("txt"), L"txt"},
  6387 estade@chromium.org   {L".", FILE_PATH_LITERAL("txt"), L"txt."},
  6387 estade@chromium.org   {L".", FILE_PATH_LITERAL(""), L"."},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL("txt"), L"footxt.dll"},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL(".txt"), L"foo.txt.dll"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL("txt"), L"footxt"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL(".txt"), L"foo.txt"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL("txt"), L"foo.baztxt.dll"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL(".txt"), L"foo.baz.txt.dll"},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL(""), L"foo.dll"},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL("."), L"foo..dll"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL(""), L"foo"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL("."), L"foo."},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL(""), L"foo.baz.dll"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL("."), L"foo.baz..dll"},
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit   {L"\\", L"", L"\\"},
     8 initial.commit   {L"\\", L"txt", L"\\txt"},
     8 initial.commit   {L"\\.", L"txt", L"\\txt."},
     8 initial.commit   {L"\\.", L"", L"\\."},
     8 initial.commit   {L"C:\\bar\\foo.dll", L"txt", L"C:\\bar\\footxt.dll"},
     8 initial.commit   {L"C:\\bar.baz\\foodll", L"txt", L"C:\\bar.baz\\foodlltxt"},
     8 initial.commit   {L"C:\\bar.baz\\foo.dll", L"txt", L"C:\\bar.baz\\footxt.dll"},
     8 initial.commit   {L"C:\\bar.baz\\foo.dll.exe", L"txt", L"C:\\bar.baz\\foo.dlltxt.exe"},
     8 initial.commit   {L"C:\\bar.baz\\foo", L"", L"C:\\bar.baz\\foo"},
     8 initial.commit   {L"C:\\bar.baz\\foo.exe", L"", L"C:\\bar.baz\\foo.exe"},
     8 initial.commit   {L"C:\\bar.baz\\foo.dll.exe", L"", L"C:\\bar.baz\\foo.dll.exe"},
     8 initial.commit   {L"C:\\bar\\baz\\foo.exe", L" (1)", L"C:\\bar\\baz\\foo (1).exe"},
   944 erikkay@google.com #elif defined(OS_POSIX)
  6387 estade@chromium.org   {L"/", "", L"/"},
  6387 estade@chromium.org   {L"/", "txt", L"/txt"},
  6387 estade@chromium.org   {L"/.", "txt", L"/txt."},
  6387 estade@chromium.org   {L"/.", "", L"/."},
  6387 estade@chromium.org   {L"/bar/foo.dll", "txt", L"/bar/footxt.dll"},
  6387 estade@chromium.org   {L"/bar.baz/foodll", "txt", L"/bar.baz/foodlltxt"},
  6387 estade@chromium.org   {L"/bar.baz/foo.dll", "txt", L"/bar.baz/footxt.dll"},
  6387 estade@chromium.org   {L"/bar.baz/foo.dll.exe", "txt", L"/bar.baz/foo.dlltxt.exe"},
  6387 estade@chromium.org   {L"/bar.baz/foo", "", L"/bar.baz/foo"},
  6387 estade@chromium.org   {L"/bar.baz/foo.exe", "", L"/bar.baz/foo.exe"},
  6387 estade@chromium.org   {L"/bar.baz/foo.dll.exe", "", L"/bar.baz/foo.dll.exe"},
  6387 estade@chromium.org   {L"/bar/baz/foo.exe", " (1)", L"/bar/baz/foo (1).exe"},
   944 erikkay@google.com #endif
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, InsertBeforeExtensionTest) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(kInsertBeforeExtension); ++i) {
  6387 estade@chromium.org     FilePath path = FilePath::FromWStringHack(kInsertBeforeExtension[i].path);
     8 initial.commit     file_util::InsertBeforeExtension(&path, kInsertBeforeExtension[i].suffix);
  6387 estade@chromium.org     EXPECT_EQ(kInsertBeforeExtension[i].result, path.ToWStringHack());
     8 initial.commit   }
     8 initial.commit }
     8 initial.commit 
     8 initial.commit static const struct filename_case {
     8 initial.commit   const wchar_t* path;
     8 initial.commit   const wchar_t* filename;
     8 initial.commit } filename_cases[] = {
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit   {L"c:\\colon\\backslash", L"backslash"},
     8 initial.commit   {L"c:\\colon\\backslash\\", L""},
     8 initial.commit   {L"\\\\filename.exe", L"filename.exe"},
     8 initial.commit   {L"filename.exe", L"filename.exe"},
     8 initial.commit   {L"", L""},
     8 initial.commit   {L"\\\\\\", L""},
     8 initial.commit   {L"c:/colon/backslash", L"backslash"},
     8 initial.commit   {L"c:/colon/backslash/", L""},
     8 initial.commit   {L"//////", L""},
     8 initial.commit   {L"///filename.exe", L"filename.exe"},
   944 erikkay@google.com #elif defined(OS_POSIX)
   944 erikkay@google.com   {L"/foo/bar", L"bar"},
   944 erikkay@google.com   {L"/foo/bar/", L""},
   944 erikkay@google.com   {L"/filename.exe", L"filename.exe"},
   944 erikkay@google.com   {L"filename.exe", L"filename.exe"},
   944 erikkay@google.com   {L"", L""},
   944 erikkay@google.com   {L"/", L""},
   944 erikkay@google.com #endif
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, GetFilenameFromPath) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(filename_cases); ++i) {
     8 initial.commit     const filename_case& value = filename_cases[i];
     8 initial.commit     std::wstring result = file_util::GetFilenameFromPath(value.path);
     8 initial.commit     EXPECT_EQ(value.filename, result);
     8 initial.commit   }
     8 initial.commit }
     8 initial.commit 
     8 initial.commit // Test finding the file type from a path name
     8 initial.commit static const struct extension_case {
     8 initial.commit   const wchar_t* path;
     8 initial.commit   const wchar_t* extension;
     8 initial.commit } extension_cases[] = {
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit   {L"C:\\colon\\backslash\\filename.extension", L"extension"},
     8 initial.commit   {L"C:\\colon\\backslash\\filename.", L""},
     8 initial.commit   {L"C:\\colon\\backslash\\filename", L""},
     8 initial.commit   {L"C:\\colon\\backslash\\", L""},
     8 initial.commit   {L"C:\\colon\\backslash.\\", L""},
     8 initial.commit   {L"C:\\colon\\backslash\filename.extension.extension2", L"extension2"},
   944 erikkay@google.com #elif defined(OS_POSIX)
   944 erikkay@google.com   {L"/foo/bar/filename.extension", L"extension"},
   944 erikkay@google.com   {L"/foo/bar/filename.", L""},
   944 erikkay@google.com   {L"/foo/bar/filename", L""},
   944 erikkay@google.com   {L"/foo/bar/", L""},
   944 erikkay@google.com   {L"/foo/bar./", L""},
   944 erikkay@google.com   {L"/foo/bar/filename.extension.extension2", L"extension2"},
   944 erikkay@google.com   {L".", L""},
   944 erikkay@google.com   {L"..", L""},
   944 erikkay@google.com   {L"./foo", L""},
   944 erikkay@google.com   {L"./foo.extension", L"extension"},
   944 erikkay@google.com   {L"/foo.extension1/bar.extension2", L"extension2"},
   944 erikkay@google.com #endif
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, GetFileExtensionFromPath) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(extension_cases); ++i) {
     8 initial.commit     const extension_case& ext = extension_cases[i];
     8 initial.commit     const std::wstring fext = file_util::GetFileExtensionFromPath(ext.path);
     8 initial.commit     EXPECT_EQ(ext.extension, fext);
     8 initial.commit   }
     8 initial.commit }
     8 initial.commit 
     8 initial.commit // Test finding the directory component of a path
     8 initial.commit static const struct dir_case {
     8 initial.commit   const wchar_t* full_path;
     8 initial.commit   const wchar_t* directory;
     8 initial.commit } dir_cases[] = {
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit   {L"C:\\WINDOWS\\system32\\gdi32.dll", L"C:\\WINDOWS\\system32"},
     8 initial.commit   {L"C:\\WINDOWS\\system32\\not_exist_thx_1138", L"C:\\WINDOWS\\system32"},
     8 initial.commit   {L"C:\\WINDOWS\\system32\\", L"C:\\WINDOWS\\system32"},
     8 initial.commit   {L"C:\\WINDOWS\\system32\\\\", L"C:\\WINDOWS\\system32"},
     8 initial.commit   {L"C:\\WINDOWS\\system32", L"C:\\WINDOWS"},
     8 initial.commit   {L"C:\\WINDOWS\\system32.\\", L"C:\\WINDOWS\\system32."},
     8 initial.commit   {L"C:\\", L"C:"},
   944 erikkay@google.com #elif defined(OS_POSIX)
   944 erikkay@google.com   {L"/foo/bar/gdi32.dll", L"/foo/bar"},
   944 erikkay@google.com   {L"/foo/bar/not_exist_thx_1138", L"/foo/bar"},
   944 erikkay@google.com   {L"/foo/bar/", L"/foo/bar"},
   944 erikkay@google.com   {L"/foo/bar//", L"/foo/bar"},
   944 erikkay@google.com   {L"/foo/bar", L"/foo"},
   944 erikkay@google.com   {L"/foo/bar./", L"/foo/bar."},
   944 erikkay@google.com   {L"/", L"/"},
   944 erikkay@google.com   {L".", L"."},
   944 erikkay@google.com   {L"..", L"."}, // yes, ".." technically lives in "."
   944 erikkay@google.com #endif
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, GetDirectoryFromPath) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(dir_cases); ++i) {
     8 initial.commit     const dir_case& dir = dir_cases[i];
     8 initial.commit     const std::wstring parent =
     8 initial.commit         file_util::GetDirectoryFromPath(dir.full_path);
     8 initial.commit     EXPECT_EQ(dir.directory, parent);
     8 initial.commit   }
     8 initial.commit }
     8 initial.commit 
   944 erikkay@google.com // TODO(erikkay): implement
   948 erikkay@google.com #if defined OS_WIN
     8 initial.commit TEST_F(FileUtilTest, CountFilesCreatedAfter) {
     8 initial.commit   // Create old file (that we don't want to count)
  4254 evanm@google.com   FilePath old_file_name = test_dir_.Append(L"Old File.txt");
     8 initial.commit   CreateTextFile(old_file_name, L"Just call me Mr. Creakybits");
     8 initial.commit 
     8 initial.commit   // Age to perfection
     8 initial.commit   Sleep(100);
     8 initial.commit 
     8 initial.commit   // Establish our cutoff time
     8 initial.commit   FILETIME test_start_time;
     8 initial.commit   GetSystemTimeAsFileTime(&test_start_time);
  4254 evanm@google.com   EXPECT_EQ(0, file_util::CountFilesCreatedAfter(test_dir_.value(),
  4254 evanm@google.com                                                  test_start_time));
     8 initial.commit 
     8 initial.commit   // Create a new file (that we do want to count)
  4254 evanm@google.com   FilePath new_file_name = test_dir_.Append(L"New File.txt");
     8 initial.commit   CreateTextFile(new_file_name, L"Waaaaaaaaaaaaaah.");
     8 initial.commit 
     8 initial.commit   // We should see only the new file.
  4254 evanm@google.com   EXPECT_EQ(1, file_util::CountFilesCreatedAfter(test_dir_.value(),
  4254 evanm@google.com                                                  test_start_time));
     8 initial.commit 
     8 initial.commit   // Delete new file, we should see no files after cutoff now
     8 initial.commit   EXPECT_TRUE(file_util::Delete(new_file_name, false));
  4254 evanm@google.com   EXPECT_EQ(0, file_util::CountFilesCreatedAfter(test_dir_.value(),
  4254 evanm@google.com                                                  test_start_time));
     8 initial.commit }
   944 erikkay@google.com #endif
     8 initial.commit 
     8 initial.commit // Tests that the Delete function works as expected, especially
     8 initial.commit // the recursion flag.  Also coincidentally tests PathExists.
     8 initial.commit TEST_F(FileUtilTest, Delete) {
     8 initial.commit   // Create a file
  4254 evanm@google.com   FilePath file_name = test_dir_.Append(FILE_PATH_LITERAL("Test File.txt"));
     8 initial.commit   CreateTextFile(file_name, L"I'm cannon fodder.");
     8 initial.commit 
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name));
     8 initial.commit 
  4254 evanm@google.com   FilePath subdir_path = test_dir_.Append(FILE_PATH_LITERAL("Subdirectory"));
  4254 evanm@google.com   file_util::CreateDirectory(subdir_path);
     8 initial.commit 
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(subdir_path));
     8 initial.commit 
  4254 evanm@google.com   FilePath directory_contents = test_dir_;
   948 erikkay@google.com #if defined(OS_WIN)
   944 erikkay@google.com   // TODO(erikkay): see if anyone's actually using this feature of the API
  4254 evanm@google.com   directory_contents = directory_contents.Append(FILE_PATH_LITERAL("*"));
     8 initial.commit   // Delete non-recursively and check that only the file is deleted
     8 initial.commit   ASSERT_TRUE(file_util::Delete(directory_contents, false));
   944 erikkay@google.com   EXPECT_FALSE(file_util::PathExists(file_name));
   944 erikkay@google.com   EXPECT_TRUE(file_util::PathExists(subdir_path));
   944 erikkay@google.com #endif
     8 initial.commit 
     8 initial.commit   // Delete recursively and make sure all contents are deleted
     8 initial.commit   ASSERT_TRUE(file_util::Delete(directory_contents, true));
   944 erikkay@google.com   EXPECT_FALSE(file_util::PathExists(file_name));
   944 erikkay@google.com   EXPECT_FALSE(file_util::PathExists(subdir_path));
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, Move) {
     8 initial.commit   // Create a directory
  4254 evanm@google.com   FilePath dir_name_from =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("Move_From_Subdir"));
  4254 evanm@google.com   file_util::CreateDirectory(dir_name_from);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(dir_name_from));
     8 initial.commit 
     8 initial.commit   // Create a file under the directory
  4254 evanm@google.com   FilePath file_name_from =
  4254 evanm@google.com       dir_name_from.Append(FILE_PATH_LITERAL("Move_Test_File.txt"));
     8 initial.commit   CreateTextFile(file_name_from, L"Gooooooooooooooooooooogle");
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit 
     8 initial.commit   // Move the directory
  4254 evanm@google.com   FilePath dir_name_to = test_dir_.Append(FILE_PATH_LITERAL("Move_To_Subdir"));
  4254 evanm@google.com   FilePath file_name_to =
  4254 evanm@google.com       dir_name_to.Append(FILE_PATH_LITERAL("Move_Test_File.txt"));
     8 initial.commit 
     8 initial.commit   ASSERT_FALSE(file_util::PathExists(dir_name_to));
     8 initial.commit 
     8 initial.commit   EXPECT_TRUE(file_util::Move(dir_name_from, dir_name_to));
     8 initial.commit 
     8 initial.commit   // Check everything has been moved.
     8 initial.commit   EXPECT_FALSE(file_util::PathExists(dir_name_from));
     8 initial.commit   EXPECT_FALSE(file_util::PathExists(file_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(dir_name_to));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name_to));
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CopyDirectoryRecursively) {
     8 initial.commit   // Create a directory.
  4254 evanm@google.com   FilePath dir_name_from =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("Copy_From_Subdir"));
  4254 evanm@google.com   file_util::CreateDirectory(dir_name_from);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(dir_name_from));
     8 initial.commit 
     8 initial.commit   // Create a file under the directory.
  4254 evanm@google.com   FilePath file_name_from =
  4254 evanm@google.com       dir_name_from.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
     8 initial.commit   CreateTextFile(file_name_from, L"Gooooooooooooooooooooogle");
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit 
     8 initial.commit   // Create a subdirectory.
  4254 evanm@google.com   FilePath subdir_name_from =
  4254 evanm@google.com       dir_name_from.Append(FILE_PATH_LITERAL("Subdir"));
  4254 evanm@google.com   file_util::CreateDirectory(subdir_name_from);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(subdir_name_from));
     8 initial.commit 
     8 initial.commit   // Create a file under the subdirectory.
  4254 evanm@google.com   FilePath file_name2_from =
  4254 evanm@google.com       subdir_name_from.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
     8 initial.commit   CreateTextFile(file_name2_from, L"Gooooooooooooooooooooogle");
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name2_from));
     8 initial.commit 
     8 initial.commit   // Copy the directory recursively.
  4254 evanm@google.com   FilePath dir_name_to =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("Copy_To_Subdir"));
  4254 evanm@google.com   FilePath file_name_to =
  4254 evanm@google.com       dir_name_to.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
  4254 evanm@google.com   FilePath subdir_name_to =
  4254 evanm@google.com       dir_name_to.Append(FILE_PATH_LITERAL("Subdir"));
  4254 evanm@google.com   FilePath file_name2_to =
  4254 evanm@google.com       subdir_name_to.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
     8 initial.commit 
     8 initial.commit   ASSERT_FALSE(file_util::PathExists(dir_name_to));
     8 initial.commit 
     8 initial.commit   EXPECT_TRUE(file_util::CopyDirectory(dir_name_from, dir_name_to, true));
     8 initial.commit 
     8 initial.commit   // Check everything has been copied.
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(dir_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(subdir_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name2_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(dir_name_to));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name_to));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(subdir_name_to));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name2_to));
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CopyDirectory) {
     8 initial.commit   // Create a directory.
  4254 evanm@google.com   FilePath dir_name_from =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("Copy_From_Subdir"));
  4254 evanm@google.com   file_util::CreateDirectory(dir_name_from);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(dir_name_from));
     8 initial.commit 
     8 initial.commit   // Create a file under the directory.
  4254 evanm@google.com   FilePath file_name_from =
  4254 evanm@google.com       dir_name_from.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
     8 initial.commit   CreateTextFile(file_name_from, L"Gooooooooooooooooooooogle");
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit 
     8 initial.commit   // Create a subdirectory.
  4254 evanm@google.com   FilePath subdir_name_from =
  4254 evanm@google.com       dir_name_from.Append(FILE_PATH_LITERAL("Subdir"));
  4254 evanm@google.com   file_util::CreateDirectory(subdir_name_from);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(subdir_name_from));
     8 initial.commit 
     8 initial.commit   // Create a file under the subdirectory.
  4254 evanm@google.com   FilePath file_name2_from =
  4254 evanm@google.com       subdir_name_from.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
     8 initial.commit   CreateTextFile(file_name2_from, L"Gooooooooooooooooooooogle");
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name2_from));
     8 initial.commit 
     8 initial.commit   // Copy the directory not recursively.
  4254 evanm@google.com   FilePath dir_name_to =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("Copy_To_Subdir"));
  4254 evanm@google.com   FilePath file_name_to =
  4254 evanm@google.com       dir_name_to.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
  4254 evanm@google.com   FilePath subdir_name_to =
  4254 evanm@google.com       dir_name_to.Append(FILE_PATH_LITERAL("Subdir"));
     8 initial.commit 
     8 initial.commit   ASSERT_FALSE(file_util::PathExists(dir_name_to));
     8 initial.commit 
     8 initial.commit   EXPECT_TRUE(file_util::CopyDirectory(dir_name_from, dir_name_to, false));
     8 initial.commit 
     8 initial.commit   // Check everything has been copied.
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(dir_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(subdir_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name2_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(dir_name_to));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name_to));
     8 initial.commit   EXPECT_FALSE(file_util::PathExists(subdir_name_to));
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CopyFile) {
     8 initial.commit   // Create a directory
  4254 evanm@google.com   FilePath dir_name_from =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("Copy_From_Subdir"));
  4254 evanm@google.com   file_util::CreateDirectory(dir_name_from);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(dir_name_from));
     8 initial.commit 
     8 initial.commit   // Create a file under the directory
  4254 evanm@google.com   FilePath file_name_from =
  4254 evanm@google.com       dir_name_from.Append(FILE_PATH_LITERAL("Copy_Test_File.txt"));
     8 initial.commit   const std::wstring file_contents(L"Gooooooooooooooooooooogle");
     8 initial.commit   CreateTextFile(file_name_from, file_contents);
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit 
     8 initial.commit   // Copy the file.
  4254 evanm@google.com   FilePath dest_file = dir_name_from.Append(FILE_PATH_LITERAL("DestFile.txt"));
     8 initial.commit   ASSERT_TRUE(file_util::CopyFile(file_name_from, dest_file));
  2060 mmoss@google.com 
   944 erikkay@google.com   // Copy the file to another location using '..' in the path.
  4254 evanm@google.com   std::wstring dest_file2(dir_name_from.ToWStringHack());
   944 erikkay@google.com   file_util::AppendToPath(&dest_file2, L"..");
   944 erikkay@google.com   file_util::AppendToPath(&dest_file2, L"DestFile.txt");
  4254 evanm@google.com   ASSERT_TRUE(file_util::CopyFile(file_name_from,
  4254 evanm@google.com                                   FilePath::FromWStringHack(dest_file2)));
  4254 evanm@google.com   std::wstring dest_file2_test(dir_name_from.ToWStringHack());
   944 erikkay@google.com   file_util::UpOneDirectory(&dest_file2_test);
   944 erikkay@google.com   file_util::AppendToPath(&dest_file2_test, L"DestFile.txt");
     8 initial.commit 
     8 initial.commit   // Check everything has been copied.
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(file_name_from));
     8 initial.commit   EXPECT_TRUE(file_util::PathExists(dest_file));
     8 initial.commit   const std::wstring read_contents = ReadTextFile(dest_file);
     8 initial.commit   EXPECT_EQ(file_contents, read_contents);
  4254 evanm@google.com   EXPECT_TRUE(file_util::PathExists(
  4254 evanm@google.com       FilePath::FromWStringHack(dest_file2_test)));
  4254 evanm@google.com   EXPECT_TRUE(file_util::PathExists(FilePath::FromWStringHack(dest_file2)));
     8 initial.commit }
     8 initial.commit 
   944 erikkay@google.com // TODO(erikkay): implement
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit TEST_F(FileUtilTest, GetFileCreationLocalTime) {
  4254 evanm@google.com   FilePath file_name = test_dir_.Append(L"Test File.txt");
     8 initial.commit 
     8 initial.commit   SYSTEMTIME start_time;
     8 initial.commit   GetLocalTime(&start_time);
     8 initial.commit   Sleep(100);
     8 initial.commit   CreateTextFile(file_name, L"New file!");
     8 initial.commit   Sleep(100);
     8 initial.commit   SYSTEMTIME end_time;
     8 initial.commit   GetLocalTime(&end_time);
     8 initial.commit 
     8 initial.commit   SYSTEMTIME file_creation_time;
  4254 evanm@google.com   file_util::GetFileCreationLocalTime(file_name.value(), &file_creation_time);
     8 initial.commit 
     8 initial.commit   FILETIME start_filetime;
     8 initial.commit   SystemTimeToFileTime(&start_time, &start_filetime);
     8 initial.commit   FILETIME end_filetime;
     8 initial.commit   SystemTimeToFileTime(&end_time, &end_filetime);
     8 initial.commit   FILETIME file_creation_filetime;
     8 initial.commit   SystemTimeToFileTime(&file_creation_time, &file_creation_filetime);
     8 initial.commit 
     8 initial.commit   EXPECT_EQ(-1, CompareFileTime(&start_filetime, &file_creation_filetime)) <<
     8 initial.commit     "start time: " << FileTimeAsUint64(start_filetime) << ", " <<
     8 initial.commit     "creation time: " << FileTimeAsUint64(file_creation_filetime);
     8 initial.commit 
     8 initial.commit   EXPECT_EQ(-1, CompareFileTime(&file_creation_filetime, &end_filetime)) <<
     8 initial.commit     "creation time: " << FileTimeAsUint64(file_creation_filetime) << ", " <<
     8 initial.commit     "end time: " << FileTimeAsUint64(end_filetime);
     8 initial.commit 
  4254 evanm@google.com   ASSERT_TRUE(DeleteFile(file_name.value().c_str()));
     8 initial.commit }
   944 erikkay@google.com #endif
     8 initial.commit 
  1089 erikkay@google.com // file_util winds up using autoreleased objects on the Mac, so this needs
  4254 evanm@google.com // to be a PlatformTest.
  1089 erikkay@google.com typedef PlatformTest ReadOnlyFileUtilTest;
     8 initial.commit 
  1089 erikkay@google.com TEST_F(ReadOnlyFileUtilTest, ContentsEqual) {
  4254 evanm@google.com   FilePath data_dir;
     8 initial.commit   ASSERT_TRUE(PathService::Get(base::DIR_SOURCE_ROOT, &data_dir));
  4254 evanm@google.com   data_dir = data_dir.Append(FILE_PATH_LITERAL("base"))
  4254 evanm@google.com                      .Append(FILE_PATH_LITERAL("data"))
  4254 evanm@google.com                      .Append(FILE_PATH_LITERAL("file_util_unittest"));
     8 initial.commit   ASSERT_TRUE(file_util::PathExists(data_dir));
     8 initial.commit 
  4254 evanm@google.com   FilePath original_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("original.txt"));
  4254 evanm@google.com   FilePath same_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("same.txt"));
  4254 evanm@google.com   FilePath same_length_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("same_length.txt"));
  4254 evanm@google.com   FilePath different_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("different.txt"));
  4254 evanm@google.com   FilePath different_first_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("different_first.txt"));
  4254 evanm@google.com   FilePath different_last_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("different_last.txt"));
  4254 evanm@google.com   FilePath empty1_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("empty1.txt"));
  4254 evanm@google.com   FilePath empty2_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("empty2.txt"));
  4254 evanm@google.com   FilePath shortened_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("shortened.txt"));
  4254 evanm@google.com   FilePath binary_file =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("binary_file.bin"));
  4254 evanm@google.com   FilePath binary_file_same =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("binary_file_same.bin"));
  4254 evanm@google.com   FilePath binary_file_diff =
  4254 evanm@google.com       data_dir.Append(FILE_PATH_LITERAL("binary_file_diff.bin"));
     8 initial.commit 
     8 initial.commit   EXPECT_TRUE(file_util::ContentsEqual(original_file, original_file));
     8 initial.commit   EXPECT_TRUE(file_util::ContentsEqual(original_file, same_file));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(original_file, same_length_file));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(original_file, different_file));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(L"bogusname", L"bogusname"));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(original_file, different_first_file));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(original_file, different_last_file));
     8 initial.commit   EXPECT_TRUE(file_util::ContentsEqual(empty1_file, empty2_file));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(original_file, shortened_file));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(shortened_file, original_file));
     8 initial.commit   EXPECT_TRUE(file_util::ContentsEqual(binary_file, binary_file_same));
     8 initial.commit   EXPECT_FALSE(file_util::ContentsEqual(binary_file, binary_file_diff));
     8 initial.commit }
     8 initial.commit 
   944 erikkay@google.com // We don't need equivalent functionality outside of Windows.
   948 erikkay@google.com #if defined(OS_WIN)
     8 initial.commit TEST_F(FileUtilTest, ResolveShortcutTest) {
  4254 evanm@google.com   FilePath target_file = test_dir_.Append(L"Target.txt");
     8 initial.commit   CreateTextFile(target_file, L"This is the target.");
     8 initial.commit 
  4254 evanm@google.com   FilePath link_file = test_dir_.Append(L"Link.lnk");
     8 initial.commit 
     8 initial.commit   HRESULT result;
     8 initial.commit   IShellLink *shell = NULL;
     8 initial.commit   IPersistFile *persist = NULL;
     8 initial.commit 
     8 initial.commit   CoInitialize(NULL);
     8 initial.commit   // Temporarily create a shortcut for test
     8 initial.commit   result = CoCreateInstance(CLSID_ShellLink, NULL,
     8 initial.commit                           CLSCTX_INPROC_SERVER, IID_IShellLink,
     8 initial.commit                           reinterpret_cast<LPVOID*>(&shell));
     8 initial.commit   EXPECT_TRUE(SUCCEEDED(result));
     8 initial.commit   result = shell->QueryInterface(IID_IPersistFile,
     8 initial.commit                              reinterpret_cast<LPVOID*>(&persist));
     8 initial.commit   EXPECT_TRUE(SUCCEEDED(result));
  4254 evanm@google.com   result = shell->SetPath(target_file.value().c_str());
     8 initial.commit   EXPECT_TRUE(SUCCEEDED(result));
     8 initial.commit   result = shell->SetDescription(L"ResolveShortcutTest");
     8 initial.commit   EXPECT_TRUE(SUCCEEDED(result));
  4254 evanm@google.com   result = persist->Save(link_file.value().c_str(), TRUE);
     8 initial.commit   EXPECT_TRUE(SUCCEEDED(result));
     8 initial.commit   if (persist)
     8 initial.commit     persist->Release();
     8 initial.commit   if (shell)
     8 initial.commit     shell->Release();
     8 initial.commit 
     8 initial.commit   bool is_solved;
  4254 evanm@google.com   std::wstring link_file_str = link_file.value();
  4254 evanm@google.com   is_solved = file_util::ResolveShortcut(&link_file_str);
     8 initial.commit   EXPECT_TRUE(is_solved);
     8 initial.commit   std::wstring contents;
  4254 evanm@google.com   contents = ReadTextFile(FilePath(link_file_str));
     8 initial.commit   EXPECT_EQ(L"This is the target.", contents);
     8 initial.commit 
   984 ericroman@google.com   // Cleaning
  4254 evanm@google.com   DeleteFile(target_file.value().c_str());
  4254 evanm@google.com   DeleteFile(link_file_str.c_str());
     8 initial.commit   CoUninitialize();
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CreateShortcutTest) {
     8 initial.commit   const wchar_t file_contents[] = L"This is another target.";
  4254 evanm@google.com   FilePath target_file = test_dir_.Append(L"Target1.txt");
     8 initial.commit   CreateTextFile(target_file, file_contents);
     8 initial.commit 
  4254 evanm@google.com   FilePath link_file = test_dir_.Append(L"Link1.lnk");
     8 initial.commit 
     8 initial.commit   CoInitialize(NULL);
  4254 evanm@google.com   EXPECT_TRUE(file_util::CreateShortcutLink(target_file.value().c_str(),
  4254 evanm@google.com                                             link_file.value().c_str(),
     8 initial.commit                                             NULL, NULL, NULL, NULL, 0));
  4254 evanm@google.com   std::wstring resolved_name = link_file.value();
     8 initial.commit   EXPECT_TRUE(file_util::ResolveShortcut(&resolved_name));
  4254 evanm@google.com   std::wstring read_contents = ReadTextFile(FilePath(resolved_name));
     8 initial.commit   EXPECT_EQ(file_contents, read_contents);
     8 initial.commit 
  4254 evanm@google.com   DeleteFile(target_file.value().c_str());
  4254 evanm@google.com   DeleteFile(link_file.value().c_str());
     8 initial.commit   CoUninitialize();
     8 initial.commit }
   944 erikkay@google.com #endif
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CreateTemporaryFileNameTest) {
     8 initial.commit   std::wstring temp_file;
  5142 estade@chromium.org   ASSERT_TRUE(file_util::CreateTemporaryFileName(&temp_file));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::PathExists(temp_file));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::Delete(temp_file, false));
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CreateNewTempDirectoryTest) {
     8 initial.commit   std::wstring temp_dir;
  5142 estade@chromium.org   ASSERT_TRUE(file_util::CreateNewTempDirectory(std::wstring(), &temp_dir));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::PathExists(temp_dir));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::Delete(temp_dir, false));
     8 initial.commit }
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, CreateDirectoryTest) {
  4254 evanm@google.com   FilePath test_root =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("create_directory_test"));
   948 erikkay@google.com #if defined(OS_WIN)
  4254 evanm@google.com   FilePath test_path =
  4254 evanm@google.com       test_root.Append(FILE_PATH_LITERAL("dir\\tree\\likely\\doesnt\\exist\\"));
   944 erikkay@google.com #elif defined(OS_POSIX)
  4254 evanm@google.com   FilePath test_path =
  4254 evanm@google.com       test_root.Append(FILE_PATH_LITERAL("dir/tree/likely/doesnt/exist/"));
   944 erikkay@google.com #endif
  2060 mmoss@google.com 
  2060 mmoss@google.com   EXPECT_FALSE(file_util::PathExists(test_path));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::CreateDirectory(test_path));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::PathExists(test_path));
  2060 mmoss@google.com   // CreateDirectory returns true if the DirectoryExists returns true.
  2060 mmoss@google.com   EXPECT_TRUE(file_util::CreateDirectory(test_path));
  2060 mmoss@google.com 
  2060 mmoss@google.com   // Doesn't work to create it on top of a non-dir
  4254 evanm@google.com   test_path = test_path.Append(FILE_PATH_LITERAL("foobar.txt"));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::PathExists(test_path));
  2060 mmoss@google.com   CreateTextFile(test_path, L"test file");
  2060 mmoss@google.com   EXPECT_TRUE(file_util::PathExists(test_path));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::CreateDirectory(test_path));
  2060 mmoss@google.com 
  2060 mmoss@google.com   EXPECT_TRUE(file_util::Delete(test_root, true));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::PathExists(test_root));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::PathExists(test_path));
     8 initial.commit }
     8 initial.commit 
  2060 mmoss@google.com TEST_F(FileUtilTest, DetectDirectoryTest) {
  2060 mmoss@google.com   // Check a directory
  4254 evanm@google.com   FilePath test_root =
  4254 evanm@google.com       test_dir_.Append(FILE_PATH_LITERAL("detect_directory_test"));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::PathExists(test_root));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::CreateDirectory(test_root));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::PathExists(test_root));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::DirectoryExists(test_root));
  2060 mmoss@google.com 
  2060 mmoss@google.com   // Check a file
  4254 evanm@google.com   FilePath test_path =
  4254 evanm@google.com       test_root.Append(FILE_PATH_LITERAL("foobar.txt"));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::PathExists(test_path));
  2060 mmoss@google.com   CreateTextFile(test_path, L"test file");
  2060 mmoss@google.com   EXPECT_TRUE(file_util::PathExists(test_path));
  2060 mmoss@google.com   EXPECT_FALSE(file_util::DirectoryExists(test_path));
  2060 mmoss@google.com   EXPECT_TRUE(file_util::Delete(test_path, false));
  2060 mmoss@google.com 
  2060 mmoss@google.com   EXPECT_TRUE(file_util::Delete(test_root, true));
  2060 mmoss@google.com }
  2060 mmoss@google.com 
   944 erikkay@google.com static const struct goodbad_pair {
     8 initial.commit   std::wstring bad_name;
     8 initial.commit   std::wstring good_name;
     8 initial.commit } kIllegalCharacterCases[] = {
     8 initial.commit   {L"bad*file:name?.jpg", L"bad-file-name-.jpg"},
     8 initial.commit   {L"**********::::.txt", L"--------------.txt"},
     8 initial.commit   // We can't use UCNs (universal character names) for C0/C1 characters and
     8 initial.commit   // U+007F, but \x escape is interpreted by MSVC and gcc as we intend.
     8 initial.commit   {L"bad\x0003\x0091 file\u200E\u200Fname.png", L"bad-- file--name.png"},
   948 erikkay@google.com #if defined(OS_WIN)
   944 erikkay@google.com   {L"bad*file\\name.jpg", L"bad-file-name.jpg"},
     8 initial.commit   {L"\t  bad*file\\name/.jpg ", L"bad-file-name-.jpg"},
     8 initial.commit   {L"bad\uFFFFfile\U0010FFFEname.jpg ", L"bad-file-name.jpg"},
   944 erikkay@google.com #elif defined(OS_POSIX)
   944 erikkay@google.com   {L"bad*file?name.jpg", L"bad-file-name.jpg"},
   944 erikkay@google.com   {L"\t  bad*file?name/.jpg ", L"bad-file-name-.jpg"},
   944 erikkay@google.com   {L"bad\uFFFFfile-name.jpg ", L"bad-file-name.jpg"},
   944 erikkay@google.com #endif
     8 initial.commit   {L"this_file_name is okay!.mp3", L"this_file_name is okay!.mp3"},
     8 initial.commit   {L"\u4E00\uAC00.mp3", L"\u4E00\uAC00.mp3"},
     8 initial.commit   {L"\u0635\u200C\u0644.mp3", L"\u0635\u200C\u0644.mp3"},
     8 initial.commit   {L"\U00010330\U00010331.mp3", L"\U00010330\U00010331.mp3"},
     8 initial.commit   // Unassigned codepoints are ok.
     8 initial.commit   {L"\u0378\U00040001.mp3", L"\u0378\U00040001.mp3"},
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, ReplaceIllegalCharactersTest) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(kIllegalCharacterCases); ++i) {
     8 initial.commit     std::wstring bad_name(kIllegalCharacterCases[i].bad_name);
     8 initial.commit     file_util::ReplaceIllegalCharacters(&bad_name, L'-');
     8 initial.commit     EXPECT_EQ(kIllegalCharacterCases[i].good_name, bad_name);
     8 initial.commit   }
     8 initial.commit }
     8 initial.commit 
     8 initial.commit static const struct ReplaceExtensionCase {
     8 initial.commit   std::wstring file_name;
  6387 estade@chromium.org   FilePath::StringType extension;
     8 initial.commit   std::wstring result;
     8 initial.commit } kReplaceExtension[] = {
  6387 estade@chromium.org   {L"", FILE_PATH_LITERAL(""), L""},
  6387 estade@chromium.org   {L"", FILE_PATH_LITERAL("txt"), L".txt"},
  6387 estade@chromium.org   {L".", FILE_PATH_LITERAL("txt"), L".txt"},
  6387 estade@chromium.org   {L".", FILE_PATH_LITERAL(""), L""},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL("txt"), L"foo.txt"},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL(".txt"), L"foo.txt"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL("txt"), L"foo.txt"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL(".txt"), L"foo.txt"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL("txt"), L"foo.baz.txt"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL(".txt"), L"foo.baz.txt"},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL(""), L"foo"},
  6387 estade@chromium.org   {L"foo.dll", FILE_PATH_LITERAL("."), L"foo"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL(""), L"foo"},
  6387 estade@chromium.org   {L"foo", FILE_PATH_LITERAL("."), L"foo"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL(""), L"foo.baz"},
  6387 estade@chromium.org   {L"foo.baz.dll", FILE_PATH_LITERAL("."), L"foo.baz"},
     8 initial.commit };
     8 initial.commit 
     8 initial.commit TEST_F(FileUtilTest, ReplaceExtensionTest) {
   944 erikkay@google.com   for (unsigned int i = 0; i < arraysize(kReplaceExtension); ++i) {
  6387 estade@chromium.org     FilePath path = FilePath::FromWStringHack(kReplaceExtension[i].file_name);
  6387 estade@chromium.org     file_util::ReplaceExtension(&path, kReplaceExtension[i].extension);
  6387 estade@chromium.org     EXPECT_EQ(kReplaceExtension[i].result, path.ToWStringHack());
     8 initial.commit   }
     8 initial.commit }
     8 initial.commit 
  2412 sky@google.com // Make sure ReplaceExtension doesn't replace an extension that occurs as one of
  2412 sky@google.com // the directory names of the path.
  2412 sky@google.com TEST_F(FileUtilTest, ReplaceExtensionTestWithPathSeparators) {
  6387 estade@chromium.org   FilePath path;
  6387 estade@chromium.org   path = path.Append(FILE_PATH_LITERAL("foo.bar"));
  6387 estade@chromium.org   path = path.Append(FILE_PATH_LITERAL("foo"));
  2412 sky@google.com   // '/foo.bar/foo' with extension '.baz'
  6387 estade@chromium.org   FilePath result_path = path;
  6387 estade@chromium.org   file_util::ReplaceExtension(&result_path, FILE_PATH_LITERAL(".baz"));
  6387 estade@chromium.org   EXPECT_EQ(path.ToWStringHack() + L".baz", result_path.ToWStringHack());
  2412 sky@google.com }
  2412 sky@google.com 
     8 initial.commit TEST_F(FileUtilTest, FileEnumeratorTest) {
     8 initial.commit   // Test an empty directory.
  6784 avi@google.com   file_util::FileEnumerator f0(test_dir_, true,
     8 initial.commit       file_util::FileEnumerator::FILES_AND_DIRECTORIES);
  6784 avi@google.com   EXPECT_EQ(f0.Next().value(), FILE_PATH_LITERAL(""));
  6784 avi@google.com   EXPECT_EQ(f0.Next().value(), FILE_PATH_LITERAL(""));
     8 initial.commit 
   944 erikkay@google.com   // create the directories
  4254 evanm@google.com   FilePath dir1 = test_dir_.Append(FILE_PATH_LITERAL("dir1"));
   944 erikkay@google.com   EXPECT_TRUE(file_util::CreateDirectory(dir1));
  4254 evanm@google.com   FilePath dir2 = test_dir_.Append(FILE_PATH_LITERAL("dir2"));
   944 erikkay@google.com   EXPECT_TRUE(file_util::CreateDirectory(dir2));
  4254 evanm@google.com   FilePath dir2inner = dir2.Append(FILE_PATH_LITERAL("inner"));
   944 erikkay@google.com   EXPECT_TRUE(file_util::CreateDirectory(dir2inner));
  4254 evanm@google.com 
   944 erikkay@google.com   // create the files
  4254 evanm@google.com   FilePath dir2file = dir2.Append(FILE_PATH_LITERAL("dir2file.txt"));
   944 erikkay@google.com   CreateTextFile(dir2file, L"");
  4254 evanm@google.com   FilePath dir2innerfile = dir2inner.Append(FILE_PATH_LITERAL("innerfile.txt"));
   944 erikkay@google.com   CreateTextFile(dir2innerfile, L"");
  4254 evanm@google.com   FilePath file1 = test_dir_.Append(FILE_PATH_LITERAL("file1.txt"));
   944 erikkay@google.com   CreateTextFile(file1, L"");
  4254 evanm@google.com   FilePath file2_rel =
  4254 evanm@google.com       dir2.Append(FilePath::kParentDirectory)
  4254 evanm@google.com           .Append(FILE_PATH_LITERAL("file2.txt"));
   944 erikkay@google.com   CreateTextFile(file2_rel, L"");
  4254 evanm@google.com   FilePath file2_abs = test_dir_.Append(FILE_PATH_LITERAL("file2.txt"));
     8 initial.commit 
     8 initial.commit   // Only enumerate files.
  6784 avi@google.com   file_util::FileEnumerator f1(test_dir_, true,
     8 initial.commit                                file_util::FileEnumerator::FILES);
     8 initial.commit   FindResultCollector c1(f1);
   944 erikkay@google.com   EXPECT_TRUE(c1.HasFile(file1));
   944 erikkay@google.com   EXPECT_TRUE(c1.HasFile(file2_abs));
   944 erikkay@google.com   EXPECT_TRUE(c1.HasFile(dir2file));
   944 erikkay@google.com   EXPECT_TRUE(c1.HasFile(dir2innerfile));
   944 erikkay@google.com   EXPECT_EQ(c1.size(), 4);
     8 initial.commit 
     8 initial.commit   // Only enumerate directories.
  6784 avi@google.com   file_util::FileEnumerator f2(test_dir_, true,
     8 initial.commit                                file_util::FileEnumerator::DIRECTORIES);
     8 initial.commit   FindResultCollector c2(f2);
   944 erikkay@google.com   EXPECT_TRUE(c2.HasFile(dir1));
   944 erikkay@google.com   EXPECT_TRUE(c2.HasFile(dir2));
   944 erikkay@google.com   EXPECT_TRUE(c2.HasFile(dir2inner));
   944 erikkay@google.com   EXPECT_EQ(c2.size(), 3);
     8 initial.commit 
  3450 tim@chromium.org   // Only enumerate directories non-recursively.
  3450 tim@chromium.org   file_util::FileEnumerator f2_non_recursive(
  6784 avi@google.com       test_dir_, false, file_util::FileEnumerator::DIRECTORIES);
  3450 tim@chromium.org   FindResultCollector c2_non_recursive(f2_non_recursive);
  3450 tim@chromium.org   EXPECT_TRUE(c2_non_recursive.HasFile(dir1));
  3450 tim@chromium.org   EXPECT_TRUE(c2_non_recursive.HasFile(dir2));
  3450 tim@chromium.org   EXPECT_EQ(c2_non_recursive.size(), 2);
  3450 tim@chromium.org 
     8 initial.commit   // Enumerate files and directories.
  6784 avi@google.com   file_util::FileEnumerator f3(test_dir_, true,
     8 initial.commit       file_util::FileEnumerator::FILES_AND_DIRECTORIES);
     8 initial.commit   FindResultCollector c3(f3);
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(dir1));
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(dir2));
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(file1));
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(file2_abs));
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(dir2file));
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(dir2inner));
   944 erikkay@google.com   EXPECT_TRUE(c3.HasFile(dir2innerfile));
   944 erikkay@google.com   EXPECT_EQ(c3.size(), 7);
     8 initial.commit 
     8 initial.commit   // Non-recursive operation.
  6784 avi@google.com   file_util::FileEnumerator f4(test_dir_, false,
     8 initial.commit       file_util::FileEnumerator::FILES_AND_DIRECTORIES);
     8 initial.commit   FindResultCollector c4(f4);
   944 erikkay@google.com   EXPECT_TRUE(c4.HasFile(dir2));
   944 erikkay@google.com   EXPECT_TRUE(c4.HasFile(dir2));
   944 erikkay@google.com   EXPECT_TRUE(c4.HasFile(file1));
   944 erikkay@google.com   EXPECT_TRUE(c4.HasFile(file2_abs));
   944 erikkay@google.com   EXPECT_EQ(c4.size(), 4);
     8 initial.commit 
     8 initial.commit   // Enumerate with a pattern.
  6784 avi@google.com   file_util::FileEnumerator f5(test_dir_, true,
  6784 avi@google.com       file_util::FileEnumerator::FILES_AND_DIRECTORIES,
  6784 avi@google.com       FILE_PATH_LITERAL("dir*"));
     8 initial.commit   FindResultCollector c5(f5);
   944 erikkay@google.com   EXPECT_TRUE(c5.HasFile(dir1));
   944 erikkay@google.com   EXPECT_TRUE(c5.HasFile(dir2));
   944 erikkay@google.com   EXPECT_TRUE(c5.HasFile(dir2file));
   944 erikkay@google.com   EXPECT_TRUE(c5.HasFile(dir2inner));
   944 erikkay@google.com   EXPECT_TRUE(c5.HasFile(dir2innerfile));
   944 erikkay@google.com   EXPECT_EQ(c5.size(), 5);
     8 initial.commit 
     8 initial.commit   // Make sure the destructor closes the find handle while in the middle of a
     8 initial.commit   // query to allow TearDown to delete the directory.
  6784 avi@google.com   file_util::FileEnumerator f6(test_dir_, true,
     8 initial.commit       file_util::FileEnumerator::FILES_AND_DIRECTORIES);
  6784 avi@google.com   EXPECT_FALSE(f6.Next().value().empty());  // Should have found something
  6784 avi@google.com                                             // (we don't care what).
     8 initial.commit }
  1287 license.bot 
  6099 estade@chromium.org 
  6099 estade@chromium.org void PathComponents(const std::wstring& path,
  6099 estade@chromium.org                     std::vector<std::wstring>* components) {
  6099 estade@chromium.org   DCHECK(components != NULL);
  6099 estade@chromium.org   if (components == NULL)
  6099 estade@chromium.org     return;
  6099 estade@chromium.org   std::wstring::size_type start = 0;
  6099 estade@chromium.org   std::wstring::size_type end = path.find('/', start);
  6099 estade@chromium.org 
  6099 estade@chromium.org   // Special case the "/" or "\" directory.  On Windows with a drive letter,
  6099 estade@chromium.org   // this code path won't hit, but the right thing should still happen.
  6099 estade@chromium.org   // "E:\foo" will turn into "E:","foo".
  6099 estade@chromium.org   if (end == start) {
  6099 estade@chromium.org     components->push_back(std::wstring(path, 0, 1));
  6099 estade@chromium.org     start = end + 1;
  6099 estade@chromium.org     end = path.find('/', start);
  6099 estade@chromium.org   }
  6099 estade@chromium.org   while (end != std::wstring::npos) {
  6099 estade@chromium.org     std::wstring component = std::wstring(path, start, end - start);
  6099 estade@chromium.org     components->push_back(component);
  6099 estade@chromium.org     start = end + 1;
  6099 estade@chromium.org     end = path.find('/', start);
  6099 estade@chromium.org   }
  6099 estade@chromium.org   std::wstring component = std::wstring(path, start);
  6099 estade@chromium.org   components->push_back(component);
  6099 estade@chromium.org }
  6099 estade@chromium.org 
  6099 estade@chromium.org static const struct PathComponentsCase {
  6099 estade@chromium.org   std::wstring path;
  6099 estade@chromium.org   FilePath::StringType result;
  6099 estade@chromium.org } kPathComponents[] = {
  6099 estade@chromium.org   {L"/foo/bar/baz/", FILE_PATH_LITERAL("/|foo|bar|baz|")},
  6099 estade@chromium.org   {L"/foo/bar/baz", FILE_PATH_LITERAL("/|foo|bar|baz")},
  6099 estade@chromium.org   {L"e:/foo", FILE_PATH_LITERAL("e:|foo")},
  6099 estade@chromium.org };
  6099 estade@chromium.org 
  6099 estade@chromium.org TEST_F(FileUtilTest, PathComponentsTest) {
  6099 estade@chromium.org   for (size_t i = 0; i < arraysize(kPathComponents); ++i) {
  6099 estade@chromium.org     FilePath path = FilePath::FromWStringHack(kPathComponents[i].path);
  6099 estade@chromium.org     std::vector<FilePath::StringType> comps;
  6099 estade@chromium.org     file_util::PathComponents(path, &comps);
  6099 estade@chromium.org 
  6099 estade@chromium.org     FilePath::StringType result;
  6099 estade@chromium.org     for (size_t j = 0; j < comps.size(); ++j) {
  6099 estade@chromium.org       result.append(comps[j]);
  6099 estade@chromium.org       if (j < comps.size() - 1)
  6099 estade@chromium.org         result.append(FILE_PATH_LITERAL("|"), 1);
  6099 estade@chromium.org     }
  6099 estade@chromium.org     EXPECT_EQ(kPathComponents[i].result, result);
  6099 estade@chromium.org   }
  6099 estade@chromium.org }
  6099 estade@chromium.org 
  7841 aa@chromium.org TEST_F(FileUtilTest, Contains) {
  7841 aa@chromium.org   FilePath data_dir;
  7841 aa@chromium.org   ASSERT_TRUE(PathService::Get(base::DIR_TEMP, &data_dir));
  7841 aa@chromium.org   data_dir = data_dir.Append(FILE_PATH_LITERAL("FilePathTest"));
  7841 aa@chromium.org 
  7841 aa@chromium.org   // Create a fresh, empty copy of this directory.
  7841 aa@chromium.org   ASSERT_TRUE(file_util::Delete(data_dir, true));
  7841 aa@chromium.org   ASSERT_TRUE(file_util::CreateDirectory(data_dir));
  7841 aa@chromium.org 
  7841 aa@chromium.org   FilePath foo(data_dir.Append(FILE_PATH_LITERAL("foo")));
  7841 aa@chromium.org   FilePath bar(foo.Append(FILE_PATH_LITERAL("bar.txt")));
  7841 aa@chromium.org   FilePath baz(data_dir.Append(FILE_PATH_LITERAL("baz.txt")));
  7841 aa@chromium.org   FilePath foobar(data_dir.Append(FILE_PATH_LITERAL("foobar.txt")));
  7841 aa@chromium.org 
  7841 aa@chromium.org   // Annoyingly, the directories must actually exist in order for realpath(),
  7841 aa@chromium.org   // which Contains() relies on in posix, to work.
  7841 aa@chromium.org   ASSERT_TRUE(file_util::CreateDirectory(foo));
  7841 aa@chromium.org   std::string data("hello");
  7841 aa@chromium.org   ASSERT_TRUE(file_util::WriteFile(bar.ToWStringHack(), data.c_str(),
  7841 aa@chromium.org                                    data.length()));
  7841 aa@chromium.org   ASSERT_TRUE(file_util::WriteFile(baz.ToWStringHack(), data.c_str(),
  7841 aa@chromium.org                                    data.length()));
  7841 aa@chromium.org   ASSERT_TRUE(file_util::WriteFile(foobar.ToWStringHack(), data.c_str(),
  7841 aa@chromium.org                                    data.length()));
  7841 aa@chromium.org 
  7841 aa@chromium.org   EXPECT_TRUE(file_util::ContainsPath(foo, bar));
  7841 aa@chromium.org   EXPECT_FALSE(file_util::ContainsPath(foo, baz));
  7841 aa@chromium.org   EXPECT_FALSE(file_util::ContainsPath(foo, foobar));
  7841 aa@chromium.org   EXPECT_FALSE(file_util::ContainsPath(foo, foo));
  7841 aa@chromium.org 
  7841 aa@chromium.org // Platform-specific concerns
  7841 aa@chromium.org   FilePath foo_caps(data_dir.Append(FILE_PATH_LITERAL("FOO")));
  7841 aa@chromium.org #if defined(OS_WIN)
  7841 aa@chromium.org   EXPECT_TRUE(file_util::ContainsPath(foo,
  7841 aa@chromium.org       foo_caps.Append(FILE_PATH_LITERAL("bar.txt"))));
  7841 aa@chromium.org   EXPECT_TRUE(file_util::ContainsPath(foo, 
  7841 aa@chromium.org       FilePath(foo.value() + FILE_PATH_LITERAL("/bar.txt"))));
  7841 aa@chromium.org #elif defined(OS_LINUX)
  7841 aa@chromium.org   EXPECT_FALSE(file_util::ContainsPath(foo,
  7841 aa@chromium.org       foo_caps.Append(FILE_PATH_LITERAL("bar.txt"))));
  7841 aa@chromium.org #else
  7841 aa@chromium.org   // We can't really do this test on osx since the case-sensitivity of the
  7841 aa@chromium.org   // filesystem is configurable.
  7841 aa@chromium.org #endif
  7841 aa@chromium.org }
  7841 aa@chromium.org 
  1955 mark@chromium.org }  // namespace
